﻿using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RavenDbMapReduceSort
{
    public class RavenDbService
    {
        public string ravenUrl = "http://localhost:8080";
        public string database = "local1";
        public RavenDbService()
            : this(null, null)
        {

        }

        public RavenDbService(string ravenUrl, string database)
        {
            if (!string.IsNullOrEmpty(ravenUrl))
                this.ravenUrl = ravenUrl;
            if (!string.IsNullOrEmpty(database))
                this.database = database;
        }

        public void SaveObject(string id, JObject obj)
        {
            var serviceChannel = new ServiceChannel(ravenUrl);
            var headers = new HeadersCollection
            {
                {"Raven-Entity-Name", obj["@metadata"]["Raven-Entity-Name"].ToString()}
            };
            var response = serviceChannel.Put<dynamic>(obj, string.Format("{0}/databases/{1}/docs/{2}", ravenUrl, database, id), headers);
        }

        public void SaveIndex(string name, JObject obj)
        {
            var serviceChannel = new ServiceChannel(ravenUrl);
            var response = serviceChannel.Put<dynamic>(obj, string.Format("{0}/databases/{1}/indexes/{2}", ravenUrl, database, name), null);
        }

        public void DeleteIndex(string name)
        {
            var serviceChannel = new ServiceChannel(ravenUrl);
            var response = serviceChannel.Delete(string.Format("{0}/databases/{1}/indexes/{2}", ravenUrl, database, name), null, null);
        }


        /*
         * reset index
         * RESET http://anoronha-lt:8080/databases/local1/indexes/Program HTTP/1.1
Accept: */
        /*
Accept-Language: en-US
Referer: http://anoronha-lt:8080/silverlight/Raven.Studio.xap
Accept-Encoding: identity
Raven-Client-Version: 2.5.0.0
Content-Type: application/json; charset=utf-8
User-Agent: Mozilla/5.0 (Windows NT 6.2; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/36.0.1985.143 Safari/537.36
Host: anoronha-lt:8080
Content-Length: 0
Connection: Keep-Alive
Pragma: no-cache

       * */

        private IServiceChannel GetServiceChannel()
        {
            return new ServiceChannel(ravenUrl);
        }
    }
}
